%define momorel 2

%define cups_user	lp
%define cups_group	lp

Summary: Common Unix Printing System
Name: cups

Version: 1.1.21rc1
Release: %{momorel}m
License: GPL
Group: System Environment/Daemons
URL: http://www.cups.org/

%NoSource 0 ftp://ftp.easysw.com/pub/cups/test/cups-%{version}-source.tar.bz2 3cf609727cbf8d8c097d16100be58a28 
Source1: cups.pamd
### obtained from CVS at bazaar.turbolinux.co.jp
### see http://bazaar.turbolinux.co.jp/cgi-bin/cvsweb.cgi/cups-extradoc/
Source2: cups-extradoc-1.1.19.tar.bz2

Source3: cups.logrotate
Source4: cups-lpd.xinetd
Source5: cups.init

# obtained from Mandrake
Source6: pap-backend.tar.bz2
Source7: pap-docu.pdf.bz2 

Patch0: cups-listen_localhost_only.patch
Patch1: cups-RunAsUser.patch
Patch100: http://bazaar.turbolinux.co.jp/~yama/Printing/CUPS/patches/1.1.16/cups-1.1.14-addlanguage-euc_jp.patch
Patch101: http://bazaar.turbolinux.co.jp/~yama/Printing/CUPS/patches/1.1.16/cups-1.1.14-disable-charset.patch
# Patch102: http://bazaar.turbolinux.co.jp/~yama/Printing/CUPS/patches/1.1.16/cups-1.1.15-accept_language.patch

Patch110: cups-extradoc-momonga.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: libpng-devel >= 1.2.2
BuildPreReq: libjpeg-devel >= 6b
BuildPreReq: libtiff-devel >= 3.4
BuildPreReq: zlib-devel >= 1.1.4-5m
BuildPreReq: openssl-devel
BuildPrereq: pam-devel
BuildPrereq: openslp-devel
BuildPrereq: autoconf

Provides: lpddaemon
Prereq: chkconfig
Conflicts: lpr, LPRng

%description
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 

%package libs
Summary: Common Unix Printing System - CUPS library
License: LGPL
Group: Development/Libraries

%description libs
The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. This package contains the CUPS API library
which contains common functions used by both the CUPS daemon and all
CUPS frontends (lpr-cups, xpp, qtcups, kups, ...).

This package you need for both CUPS clients and servers. 

%package devel
Summary: Common Unix Printing System - development environment
License: LGPL
Group: Development/Libraries
Requires: %{name}-libs = %{version}-%{release}

%description devel
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. This is the development package for creating
additional printer drivers, and other CUPS services.

%prep
%setup -q -a 2 -a 6
bzcat %{SOURCE7} > `basename %{SOURCE7} .bz2`

%patch -p0 -b .localhost~
%patch1 -p0 -b .panpi~

%patch100 -p1
#%patch101 -p1
#%patch102 -p1

(
  cd cups-extradoc
%patch110 -p1
  %__perl -i -p -e 's/gif/png/g;' ja/doc/*.{html,css} ja/templates/*.tmpl
)

# for requires chain loop
#perl -p -i -e "s|\trm\s+-f\s+\./\*\.gif|#\trm -f ./*.gif|" cups-extradoc/ja/doc/images/Makefile

autoconf

%build
%configure \
  --with-logdir=/var/log/cups \
  --localstatedir=/var \
  --enable-slp \
  --with-openssl \
  --with-cups-user=%{cups_user} \
  --with-cups-group=%{cups_group}

# If we got this far, all prerequisite libraries must be here.
%make

%install
# Make sure the RPM_BUILD_ROOT directory exists.
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%define _makeinstall_args %nil
%makeinstall BUILDROOT=%{buildroot}

(
  cd cups-extradoc
  %makeinstall BUILDROOT=%{buildroot}
  %__mv %{buildroot}%{_datadir}/cups/doc/ja %{buildroot}%{_datadir}/doc/cups/
  %__rm -rf %{buildroot}%{_datadir}/cups/doc
)

## install pap backend
%__install -m 755 pap-backend/pap %{buildroot}%{_libdir}/cups/backend/

## make symbolic link for printing via samba
%__ln_s /usr/bin/smbspool %{buildroot}%{_libdir}/cups/backend/smb

%__mkdir_p %{buildroot}/%{_initscriptdir}
%__cp %SOURCE5 %{buildroot}/%{_initscriptdir}/cups
%__cp %SOURCE1 %{buildroot}%{_sysconfdir}/pam.d/
%__mkdir_p %{buildroot}%{_sysconfdir}/{logrotate,xinetd}.d
%__cp %SOURCE3 %{buildroot}%{_sysconfdir}/logrotate.d/cups
%__cp %SOURCE4 %{buildroot}%{_sysconfdir}/xinetd.d/cups-lpd

# remove unwanting files.
rm -rf %{buildroot}/etc/rc.d
rm -rf %{buildroot}%{_mandir}/cat*
rm -rf %{buildroot}%{_mandir}/*/cat*

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%post
/sbin/chkconfig --add cups

if [ ! -f %{_sysconfdir}/cups/pdftops.conf -a \
     ! -L %{_sysconfdir}/cups/pdftops.conf ]; then
  %__ln_s %{_sysconfdir}/xpdfrc %{_sysconfdir}/cups/pdftops.conf
fi

%preun
if [ "$1" = 0 ]; then
  %{_initscriptdir}/cups stop
  /sbin/chkconfig --del cups

  if [ -L %{_sysconfdir}/cups/pdftops.conf ]; then
    %__rm %{_sysconfdir}/cups/pdftops.conf
  fi
fi

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc *.txt pap-docu.pdf
%dir %{_sysconfdir}/cups
%attr(0711,%{cups_user},root) %dir %{_sysconfdir}/cups/certs
%dir %{_sysconfdir}/cups/interfaces
%dir %{_sysconfdir}/cups/ppd
%config(noreplace) %{_sysconfdir}/cups/*.conf
%config            %{_sysconfdir}/cups/mime.*
%config(noreplace) %{_sysconfdir}/pam.d/*
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%config(noreplace) %{_sysconfdir}/xinetd.d/*
%{_initscriptdir}/cups
%{_bindir}/cancel
%{_bindir}/cupstestppd
%{_bindir}/disable
%{_bindir}/enable
%{_bindir}/lp
%{_bindir}/lpoptions
%attr(4755,%{cups_user},root) %{_bindir}/lppasswd
%{_bindir}/lpq
%{_bindir}/lpr
%{_bindir}/lprm
%{_bindir}/lpstat
%dir %{_libdir}/cups
%dir %{_libdir}/cups/backend
%{_libdir}/cups/backend/*
%dir %{_libdir}/cups/cgi-bin
%{_libdir}/cups/cgi-bin/*
%dir %{_libdir}/cups/daemon
%{_libdir}/cups/daemon/*
%dir %{_libdir}/cups/filter
%{_libdir}/cups/filter/*
%{_sbindir}/*
%dir %{_datadir}/cups
%dir %{_datadir}/cups/banners
%{_datadir}/cups/banners/*
%dir %{_datadir}/cups/charsets
%{_datadir}/cups/charsets/*
%dir %{_datadir}/cups/data
%{_datadir}/cups/data/*
%dir %{_datadir}/cups/model
%{_datadir}/cups/model/*
%dir %{_datadir}/cups/templates
%{_datadir}/cups/templates/*
%dir %{_datadir}/doc/cups
%docdir %{_datadir}/doc/cups
%{_datadir}/doc/cups/*
%{_datadir}/locale/*/*
%dir %{_datadir}/cups/fonts
%{_datadir}/cups/fonts/*
%attr(0700,%{cups_user},root) %dir %{_var}/spool/cups
%attr(1700,%{cups_user},root) %dir %{_var}/spool/cups/tmp
%{_mandir}/man*/*
%{_mandir}/fr/man*/*
%dir %{_var}/log/cups

%files libs
%defattr(-,root,root)
%{_libdir}/lib*.so.*

%files devel
%defattr(-,root,root)
%dir %{_includedir}/cups
%{_bindir}/cups-config
%{_includedir}/cups/*
%{_libdir}/*.a
%{_libdir}/*.so

%changelog
* Sat Jul  3 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.21rc1-2m)
- stop daemon

* Fri Jun 18 2004 kourin <kourin@fh.freeserve.ne.jp>
- (1.1.21rc1-1m)
- update to 1.1.21rc1
 
* Tue Mar 15 2004 Toru Hoshina <t@momonga-linux.org>
- (1.1.19-11m)
- revised spec for enabling rpm 4.2.

* Wed Oct 29 2003 Kenta MURATA <muraken2@nifty.com>
- (1.1.19-10m)
- pretty spec file.

* Fri Aug  1 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.19-10m)
- fix RunAsUser...

* Thu Jul 31 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.19-9m)
- add pap backend (obtained from Mandrake)
- set default group to "lp" instead of "sys"
- add cups-RunAsUser.patch to run cupsd as ordinary user (not root)
- fix typo (s/linsten/listen/)

* Wed Jul 23 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.19-8m)
- use .png images instead of .gif images

* Wed Jul 23 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.19-7m)
- [IMPORTANT] Make cupsd listen(2) only localhost by default.
  To make cupsd accept connections from outside,
  "Listen" directive in /etc/cupsd.conf must be changed
  (and "Allow","Deny" directives too, of course).
- according to http://www.cups.org/str.php?L196,
  pdftops reads /etc/cups/pdftops.conf instead of /etc/xpdfrc,
  so make a symlink from /etc/xpdfrc to /etc/cups/pdftops.conf and
  remove cups-1.1.19-xpdfrc.patch.
- make %{_sysconfdir}/cups/mime.* be replacable
  (normally these files are not edited by hand)
- add %{_var}/log/cups to %%files
- use redhat's initscript (cups.init)
- add xinetd file for cups-lpd
- import config file for logrotate (cups.logrotate) from redhat
- do not own %{_sysconfdir}/pam.d
- add more documents

* Sun Jul 20 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.19-6m)
- update cups-extradoc to 1.1.19
  (obtained from CVS at bazaar.turbolinux.co.jp)
- add %%{_bindir}/cupstestppd
- run /sbin/ldconfig at %%post and %%postun section of -libs
- use %%make and %%makeinstall

* Sun Jul 20 2003 Kazuhiko <kazuhiko@fdiary.net>
- (1.1.19-5m)
- rebuild against glibc-2.3.2                               

* Wed Jun 25 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.19-4m)
- add cups-1.1.19-xpdfrc.patch to make pdftops read /etc/xpdfrc

* Tue Jun 24 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.19-3m)
- modify %%post and %%preun sections
  (do not run chkconfig --del on upgrade)

* Tue Jun 17 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.1.19-2m)
  don't remade gif images.

* Wed May 28 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.1.19-1m)
  update to 1.1.19

* Fri May 23 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.1.18-5m)
- enable slp
- %%{?_smp_mflags}
- add Japanese resource

* Tue Apr 08 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.1.18-4m)
- rebuild against zlib 1.1.4-5m

* Sat Mar 22 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.18-3m)
- make symbolic link for printing via samba
  (requested by nosanosa [Momonga-devel.ja:01495])
- cups-devel: add %%{release} to Requires:

* Thu Mar 20 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.1.18-2m)
- make subpackage "libs"
- move from Zoo to Main
- do not include cat pages
- remove pstoraster subpackage

* Sat Mar 15 2003 Kikutani Makoto <poo@momonga-linux.org>
- (1.1.18-1m)
- new upstream version
- require ghostscript-cups

* Sat Apr 20 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (1.1.14-4k)
- rebuild against libpng 1.2.2.

* Thu Mar 14 2002 Tsutomu Yasuda <tom@kondara.org>
- (1.1.14-2k)
  merge from STABLE_2_1(by zaki <zaki@kondara.org>)
  update to 1.1.14 (buffer overflow fixed version)
  http://online.securityfocus.com/bid/4100

* Sat Jan 12 2002 OZAWA -Crouton- Sakuro <crouton@kondara.org>
- (1.1.10-12k)
- Removed Packager and Vendotr tag.

* Mon Nov 12 2001 Shingo Akagaki <dora@kondara.org>
- (1.1.10-10k)
- devel reqs main

* Thu Nov  8 2001 Shingo Akagaki <dora@kondara.org>
- (1.1.10-8k)
- nigirisugi

* Tue Oct 30 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (1.1.10-6k)
- modify deffattr problem

* Tue Oct 16 2001 Toru Hoshina <t@kondara.org>
- (1.1.10-4k)
- rebuild against libpng 1.2.0.
